//
//  RRSDKBase.m
//  RenRenSDK
//
//  Created by rannger on 12-8-23.
//  Copyright (c) 2012年 rannger. All rights reserved.
//

#import "RRSDKBase.h"
#import "RequestUrl.h"
//#import "MD5Util.h"

#define AppKey @"ccdd4f0183594a95af66202e61c40de9"
#define SecretKey @"8921cab30e534f9fb2013a77bc4c267d"
#define RedirectUri @"http://graph.renren.com/oauth/login_success.html"

#ifndef AppKey
#error AppKey not define
#endif

#ifndef SecretKey
#error SecretKey not define
#endif

#ifndef RedirectUri
#error RedirectUri not define
#endif


@implementation RRSDKBase

+ (NSString*)renrenAppKey
{
    return AppKey;
}

+ (NSString*)renrenSecretKey
{
    return SecretKey;
}

+ (NSString*)redirectUri
{
    return RedirectUri;
}


+ (NSDictionary*)parseUrlParam:(NSURL*)url
{
    NSString *str=url.absoluteString;
    NSString* urlString=[url query];
    NSMutableDictionary *queryStringDictionary = [[NSMutableDictionary alloc] init];
    NSArray *urlComponents=nil;
    if([urlString length]!=0)
    {
        urlComponents = [urlString componentsSeparatedByString:@"&"];
    }
    else
    {
        NSRange range=[str rangeOfCharacterFromSet:[NSCharacterSet characterSetWithCharactersInString:@"#&"]];
        if (range.location!=NSNotFound) {
            urlComponents=[str componentsSeparatedByCharactersInSet:
                           [NSCharacterSet characterSetWithCharactersInString:@"#&"]];
        }
        
    }
    
    for (NSString *keyValuePair in urlComponents)
    {
        if ([keyValuePair rangeOfString:@"="].location!=NSNotFound) {
            NSArray *pairComponents = [keyValuePair componentsSeparatedByString:@"="];
            NSString *key = [pairComponents objectAtIndex:0];
            NSString *value = [pairComponents objectAtIndex:1];
            
            [queryStringDictionary setObject:value forKey:key];
        }
    }
    return [queryStringDictionary autorelease];
}

+ (NSString*)genSignature:(NSDictionary*)params
{
    NSMutableString* string=[[NSMutableString alloc] init];
    NSArray* keys=[params allKeys];
    NSMutableArray* mutableArray=[[NSMutableArray alloc] init];
    for (NSString* key in keys)
    {
        [mutableArray addObject:[NSString stringWithFormat:@"%@=%@",key,[params objectForKey:key]]];
    }
    [mutableArray sortUsingSelector:@selector(compare:)];
    for (NSString* item in mutableArray) {
        [string appendString:item];
    }
    [string appendString:[RRSDKBase renrenSecretKey]];
    NSString* retval=[RRSDKBase md5:string];
    [string release];
    [mutableArray release];
    return retval;
}

+ (NSString *) md5:(NSString *)str
{
    if( nil == str )
        return nil;
    const char *cStr = [str UTF8String];
    unsigned char result[16];
    CC_MD5( cStr, strlen(cStr), result );
    return [[NSString stringWithFormat:
             @"%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",
             result[0], result[1], result[2], result[3],
             result[4], result[5], result[6], result[7],
             result[8], result[9], result[10], result[11],
             result[12], result[13], result[14], result[15]
             ] uppercaseString];
}

@end
